/* This is file SCREEN.C */
/*
** Copyright (C) 1991 DJ Delorie, 24 Kirsten Ave, Rochester NH 03867-2954
**
** This file is distributed under the terms listed in the document
** "copying.dj", available from DJ Delorie at the address above.
** A copy of "copying.dj" should accompany this file; if not, a copy
** should be available from where this file was obtained.  This file
** may not be distributed without a verbatim copy of "copying.dj".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
**
** Modified by J. Alan Eldridge, Liberty Brokerage, 77 Water St., NYC 10005
**  Fixed ScreenRows() - the memory location it references is rows - 1, so
**  have to add 1 before returning value.  Added ScreenMode().
*/

#include "pc.h"

int ScreenRows()
{
  return *(unsigned char *)0xe0000484 + 1;
}

int ScreenCols()
{
  return *(unsigned short *)0xe000044a;
}

int ScreenMode()
{
  return *(unsigned char *)0xe0000449;
}

void ScreenPutChar(int ch, int attr, int x, int y)
{
  ch &= 0xff;
  attr = (attr & 0xff) << 8;
  if ((x < 0) || (y < 0) || (x >= ScreenCols()) || (y > ScreenRows()))
    return;
  *(unsigned short *)(0xe01b8000+x*2+y*ScreenCols()*2) = ch | attr;
}
